require 'vikiwikiplugin'

module VikiWiki
	module Plugins
		class Passwd
			include BaseModule
			def ondesc; <<DSC; end
The system plugin can manage the users and passwords.
DSC
			ERR = Hash::new unless defined? ERR
			ERR['PAS_CHK'] = "Invalid password for checking is specified."
			HED = Hash::new unless defined? HED
			HED['ALT_PAS'] = 'AlterPassword'
			HED['DEL_USR'] = 'DeleteUser'
			HED['REG_USR'] = 'RegistUser'
			LBL = Hash::new unless defined? LBL
			LBL['ALT_PAS'] = 'AlterPassword'
			LBL['DEL_USR'] = 'DeleteUser'
			LBL['PAS_CHK'] = 'Password(for checking)'
			LBL['PAS_NAM'] = 'Password'
			LBL['PAS_NOW'] = 'CurrentPassword'
			LBL['REG_USR'] = 'RegistUser'
			LBL['USR_NAM'] = 'User'
			MSG = Hash::new unless defined? MSG
			MSG['ALT_PAS'] = "Alter password for user %1."
			MSG['REG_USR'] = "Regist user %1."

			def safe; 3 ; end
			def onpost
				wuser = @sys.cgi.params['passwd_user'][0]
				wpass = @sys.cgi.params['passwd_password'][0]
				wold = @sys.cgi.params['passwd_oldpassword'][0]
				wchk = @sys.cgi.params['passwd_chkpassword'][0]
				case @sys.cgi.params['passwd_mode'][0]
				when 'add' then
					raise ERR['PAS_CHK'] if wpass != wchk
					@sys.sec.update(wuser, nil, wpass)
					msg(MSG['REG_USR'].emb(wuser))
				when 'alt' then
					raise ERR['PAS_CHK'] if wpass != wchk
					@sys.sec.update(wuser, wold, wpass)
					msg(MSG['ALT_PAS'].emb(wuser))
=begin
				when LBL['DEL_USR'] then
					@sys.sec.delete(wuser, wpass)
=end
				end
			end
			def onview
				arr = Array::new
				arr << msg
				arr << CGI::element('h2', nil, HED['REG_USR'])
				arr << plugin_form({'passwd_mode'=>'add'}) {|recv|
					recv << [LBL['USR_NAM'], text('passwd_user', '', 10)]
					recv << [LBL['PAS_NAM'], password('passwd_password', 10)]
					recv << [LBL['PAS_CHK'], password('passwd_chkpassword', 10)]
					recv << [submit('exec', LBL['REG_USR']), nil]
				}
				arr << CGI::element('h2', nil, HED['ALT_PAS'])
				arr << plugin_form({'passwd_mode'=>'alt'}) {|recv|
					recv << [LBL['USR_NAM'], text('passwd_user', '', 10)]
					recv << [LBL['PAS_NOW'], password('passwd_oldpassword', 10)]
					recv << [LBL['PAS_NAM'], password('passwd_password', 10)]
					recv << [LBL['PAS_CHK'], password('passwd_chkpassword', 10)]
					recv << [submit('exec',LBL['ALT_PAS']), nil]
				}
=begin
				arr << CGI::element('h2', nil, HED['DEL_USR'])
				arr << plugin_form({'passwd_mode'=>'del'}) {|recv|
					recv << [LBL['USR_NAM'], text('passwd_user', '', 10)]
					recv << [LBL['PAS_NAM'], password('passwd_password', 10)]
					recv << [submit('exec',LBL['DEL_USR']), nil]
				}
=end
				return arr.join("\n")
			end
		end
	end
end
